<template>
  <svn-pro-card color="onSurface" class="relative" :rounded="'xs'" elevation="3">
    <div
      class="max-w-[475px] h-full inline-flex pl-6 pr-4 py-4 items-start bg-onSurface"
      :class="progressBar ? 'gap-8' : 'gap-6'"
    >
      <div class="flex flex-col items-start gap-4">
        <div class="flex flex-col gap-1 items-start">
          <div class="flex gap-1 items-center">
            <div v-if="toastType !== 'badge'">
              <Icon
                :icon="getIcon()"
                height="20"
                width="20"
                class="text-onPrimary"
              />
            </div>

            <v-img
              v-else
              class="w-10 h-10"
              cover
              :src="getBadge()"
            />

            <svn-pro-text subtitle-large bold color="onPrimary">
              {{ toastTitle }}
            </svn-pro-text>
          </div>

          <svn-pro-text body-medium regular color="onPrimary">
            <span v-html="toastDescription"/>
          </svn-pro-text>
        </div>

        <svn-pro-button
          v-if="action"
          color="surface"
          variant="elevated"
          :text="actionText"
        />
      </div> 

      <svn-pro-icon-button icon="mdi-close" variant="text" color="onPrimary" />
    </div>

    <svn-pro-progress-linear
      v-if="progressBar"
      color="onPrimary"
      bg-color="transparent"
      indeterminate
      class="-mt-1"
    />
  </svn-pro-card>
</template>

<script setup>
import { Icon } from '@iconify/vue';
import SvnProCard from '../card/SvnProCard.vue';
import SvnProText from '../styles/SvnProText.vue';
import SvnProButton from '../button/SvnProButton.vue';
import SvnProIconButton from '../button/SvnProIconButton.vue';
import SvnProProgressLinear from '../progress/SvnProProgressLinear.vue';
import Training from '../../assets/badge_book.svg';
import Module from '../../assets/badge_puzzle.svg';
import Reaction from '../../assets/badge_thumb.svg';
import Like from '../../assets/badge_heart.svg';

const props = defineProps({
  toastType: {
    type: String,
    default: "success",
  },
  toastTitle: {
    type: String,
    default: "Your document is ready",
  },
  toastDescription: {
    type: String,
    default: 'Your document PDF "document title" has been successfully  downloaded',
  },
  actionText: {
    type: String,
    default: "Action",
  },
  badge: {
    type: String,
    default: "trainings"
  },
  progressBar: {
    type: Boolean,
    default: false,
  },
  action: {
    type: Boolean,
    default: false,
  }
})

const getBadge = () => {
  if (props.badge === "trainings") {
    return Training
  } else if (props.badge === "modules") {
    return Module
  } else if (props.badge === "reactions") {
    return Reaction
  } else if (props.badge === "likes") {
    return Like
  }
}

const getIcon = () => {
  if (props.toastType === "success") {
    return "mingcute:check-circle-fill"
  } else if (props.toastType === "info") {
    return "mingcute:information-line"
  } else if (props.toastType === "warning") {
    return "mingcute:alert-fill"
  } else if (props.toastType === "error") {
    return "mingcute:close-circle-fill"
  }
}
</script>